#ifndef THREADS_H
#define THREADS_H

typedef void *iao_mutex;
typedef void *iao_thread;

iao_thread iao_spawnthread(void (*start_routine)(void*), void *arg);
iao_thread iao_spawnthread_nojoin(void (*start_routine)(void*), void *arg);

/* must call join thread if created by iao_spawnthread */
int iao_jointhread(iao_thread thread);
iao_mutex iao_createmutex();
int iao_lockmutex(iao_mutex mutex);
int iao_releasemutex(iao_mutex mutex);
int iao_deletemutex(iao_mutex mutex);
int iao_safecreatemutex(iao_mutex *mutex);

/* If you are calling the library from a thread not created by iao_threadcreate */
/* you must call iao_createglobalmutex before any other call to the ciao lib    */
void iao_createglobalmutex();


void iao_logmsg(char *msg);
void iao_logsysmsg(char *msg);

#endif
